var can, pos;
var texte0, texte1, gliss1, texte2, gliss1;
var caseCocher1, caseCocher2, caseCocher3, texteC1, texteC2, texteC3, texteC3bas;
var caseCocherQ, texteCQ;
var margeX=0, margeY=40, ecart=20, gauche=308, haut=0, cote=600, dim, margeCocherX=20, margeCocherY=-5;
var rayon, nbPix, nbPixD, pixel;
var disqueP=true, quadrilP = false, pixelsP=false, triangleP=false, opacite; var taillePixelsInitiale = 15, pointCourantInitial=75;

function setup() {
   can = createCanvas(910, 601);
   can.parent('pourP5');
   background(255);
   pos=findPos(can.elt);
   
   texte0 = createElement('text', 'Montrer');
   texte0.style('font-size','18px');
   
   caseCocher1 = createCheckbox('', disqueP);
   texteC1 = createElement('text', 'le cercle à modéliser');
   texteC1.style('font-size','18px');
   
   caseCocherQ = createCheckbox('', quadrilP);
   texteCQ = createElement('text', 'la grille des pixels');
   texteCQ.style('font-size','18px');
   
   caseCocher2 = createCheckbox('', pixelsP);
   texteC2 = createElement('text', 'les pixels utilisés');
   texteC2.style('font-size','18px');
   
   caseCocher3 = createCheckbox('', triangleP);
   texteC3 = createElement('text', 'le triangle de Pythagore');
   texteC3.style('font-size','18px');
   texteC3bas = createElement('text', 'associé au pixel courant');
   texteC3bas.style('font-size','18px');
   
   texte1 = createElement('text', ' Taille des pixels (décroissante)');
   texte1.style('font-size','18px');
   
   gliss1=createSlider(1,200,taillePixelsInitiale);
   gliss1.style('width', '300px');
   
   texte2 = createElement('text', ' Parcourir les pixels calculés');
   texte2.style('font-size','18px');
   
   gliss2=createSlider(-1,100,pointCourantInitial);
   gliss2.style('width', '300px');
}

function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
	   do {	curleft += obj.offsetLeft;
	   		curtop += obj.offsetTop;
		  } while (obj = obj.offsetParent);
	return [curleft,curtop];
    }
}


function draw(){
   var x, y, u, v, borne, k;
   
   pos=findPos(can.elt);
   texte0.position(pos[0]+margeX, pos[1]+margeY-1*ecart+margeCocherY);
   caseCocher1.position(pos[0]+margeX, pos[1]+margeY+0*ecart);
   texteC1.position(pos[0]+margeX+margeCocherX, pos[1]+margeY+0*ecart+margeCocherY);
   caseCocherQ.position(pos[0]+margeX, pos[1]+margeY+1*ecart);
   texteCQ.position(pos[0]+margeX+margeCocherX, pos[1]+margeY+1*ecart+margeCocherY);
   
   caseCocher2.position(pos[0]+margeX, pos[1]+margeY+2*ecart);
   texteC2.position(pos[0]+margeX+margeCocherX, pos[1]+margeY+2*ecart+margeCocherY);
   caseCocher3.position(pos[0]+margeX, pos[1]+margeY+3*ecart);
   texteC3.position(pos[0]+margeX+margeCocherX, pos[1]+margeY+3*ecart+margeCocherY);
   texteC3bas.position(pos[0]+margeX+margeCocherX, pos[1]+margeY+4*ecart+margeCocherY);
   texte1.position(pos[0]+margeX, pos[1]+margeY+7*ecart); 
   gliss1.position(pos[0]+margeX, pos[1]+margeY+8*ecart);
   texte2.position(pos[0]+margeX, pos[1]+margeY+10*ecart);
   gliss2.position(pos[0]+margeX, pos[1]+margeY+11*ecart);
   
   disqueP = caseCocher1.checked();
   quadrilP = caseCocherQ.checked();
   pixelsP = caseCocher2.checked();
   triangleP = caseCocher3.checked();
   
   background(255);
   rayon = cote/2;
   nbPixD=round(gliss1.value()); if (nbPixD>190) {nbPixD=2*nbPixD;};
   nbPix=2*nbPixD+1; dim=cote/nbPix; 
   pixel=round(gliss2.value());
   
   if (disqueP) {stroke(0,0,0);noFill(); ellipse(gauche+rayon, haut+rayon, cote, cote); opacite=150;} //  fill(240,240,255); 
   else {opacite=255;};
   
   stroke(200); // tracer la grille
   if (quadrilP && nbPixD < 50) {
   	  for(k=0;k<=nbPix;k++) {line(gauche+k*dim, haut, gauche+k*dim, haut+cote);};
      for(k=0;k<=nbPix;k++) {line(gauche, haut+k*dim, gauche+cote, haut+k*dim);};
   }
   
  borne=nbPixD; 
  for(u=0;u<=nbPixD;u++) { // tracer les "pixels"
   		x = u*dim; y=sqrt(rayon*rayon-x*x); v = floor((floor(2*y/dim)+1)/2); if (nbPixD<v) {v = nbPixD;};
   		if (v<u) {borne=u-1; break;};
   		fill(200, 200, 200, opacite); stroke(200); tracerPixel(u, -v); tracerPixel(-u, v); tracerPixel(-u, -v);
   				   tracerPixel(v, u); tracerPixel(-v, u); tracerPixel(v, -u); tracerPixel(-v, -u);
   		fill(0, 0, 0, opacite); stroke(0); tracerPixel(u, v);
   };
   
   fill(0,255,0, opacite); tracerPixel(0,0); // tracer le pixel courant, et ses symétriques
   if (pixel>=0) {
   		u=round(borne*pixel/100); x = u*dim; y=sqrt(rayon*rayon-x*x); v = floor((floor(2*y/dim)+1)/2); if (nbPixD<v) {v = nbPixD;}; 
   		stroke(255,0,0); 
   		fill(255,200,200, opacite); tracerPixel(u, -v); tracerPixel(-u, v); tracerPixel(-u, -v);
   				   tracerPixel(v, u); tracerPixel(-v, u); tracerPixel(v, -u); tracerPixel(-v, -u);
   		fill(255,0,0, opacite); tracerPixel(u, v);
   }
   
   if (triangleP && (pixel>=0)) { // tracer le triangle
   		u=round(borne*pixel/100); x = u*dim; y=sqrt(rayon*rayon-x*x); v = floor((floor(2*y/dim)+1)/2); if (nbPixD<v) {v = nbPixD;};
   		stroke(0,0,255);
   		line(centrePixelX(0), centrePixelY(0), centrePixelX(u), centrePixelY(0));
   		line(centrePixelX(0), centrePixelY(0), centrePixelX(u), rayon-y);
   		stroke(255,127,0); if (disqueP) {strokeWeight(1);} else {strokeWeight(2);}
   		line(centrePixelX(u), centrePixelY(0), centrePixelX(u), rayon-y); strokeWeight(1);
   }
}

function tracerPixel(u,v) {
	if (!pixelsP) {return;};
	u=u+nbPixD; v=-v+nbPixD;
	rect(gauche+u*dim, haut+v*dim, dim, dim);
}

function centrePixelX(u) {return gauche+(u+nbPixD+0.5)*dim;}
function centrePixelY(v) {return haut+(-v+nbPixD+0.5)*dim;}